//
//  GestureView.m
//  Hour11
//
//  Created by Kevin Hoffman on 7/20/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "GestureView.h"

@implementation GestureView

@synthesize lionView;

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
        [self setAcceptsTouchEvents:YES];

    }
    
    return self;
}

- (void)touchesBeganWithEvent:(NSEvent *)event
{
 //   NSLog(@"Touches began!");
}

- (void)touchesMovedWithEvent:(NSEvent *)event {
   // NSLog(@"touches moved!");
}

- (void)touchesEndedWithEvent:(NSEvent *)event  {
  //  NSLog(@"Touches ended!");
}

- (void)rotateWithEvent:(NSEvent *)event {
    CGFloat currentRotation = [lionView frameCenterRotation];
    CGFloat newRotation = [event rotation];
    NSLog(@"requesting rotate to %f", newRotation);
    [lionView setFrameCenterRotation:currentRotation + newRotation];
}
-(void)magnifyWithEvent:(NSEvent *)event {
    CGFloat magFactor = event.magnification;
    NSLog(@"Magnify gesture detected, zoom factor: %f", magFactor);
    
    NSSize newSize = lionView.frame.size;
    newSize.height = newSize.height * (magFactor + 1.0);
    newSize.width = newSize.width * (magFactor + 1.0);
    [lionView setFrameSize:newSize]; 
}

- (void)swipeWithEvent:(NSEvent *)event {
    NSLog(@"swipe detected");
    CGFloat dX = event.deltaX;
    CGFloat dY = event.deltaY;

    
    if (dX > 0) {
        // swiped left
        lionView.frame = NSMakeRect(0.0, lionView.frame.origin.y, 
                                    lionView.frame.size.width,
                                    lionView.frame.size.height);
    }
    else if (dX < 0) {
        // swiped right
    }
    else if (dY > 0) {
        // swiped up
    }
    else {
        // swiped down
    }
    [self setNeedsDisplay:YES];
    
}

- (void)drawRect:(NSRect)dirtyRect
{
    // Drawing code here.
    [[NSColor lightGrayColor] set];
    NSRectFill([self bounds]);
}

@end
