//
//  Hour10AppDelegate.m
//  Hour10
//
//  Created by Kevin Hoffman on 7/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Hour10AppDelegate.h"
#import "Customer.h"
#import "TreeNodeData.h"

@implementation Hour10AppDelegate
@synthesize sampleTreeController = _sampleTreeController;
@synthesize sampleOutlineView = _sampleOutlineView;

@synthesize window = _window;
@synthesize customersArrayController = _customersArrayController;


- (NSArray *)generateTree
{
    NSString *rootStrings[] = {@"Cool", @"Sorta Cool", @"Not So Cool", @"Lame"};
    NSMutableArray *roots = [NSMutableArray array];
    for (int i=0; i<4; i++)
    {
        TreeNodeData *nodeData = [TreeNodeData new];
        nodeData.nodeName = rootStrings[i];
        NSTreeNode *node = [NSTreeNode treeNodeWithRepresentedObject:nodeData];
        for (int j=0; j<10; j++)
        {
            TreeNodeData *level2Data = [TreeNodeData new];
            level2Data.nodeName = [NSString stringWithFormat:@"node %d", j+1];
            NSTreeNode *level2Node = [NSTreeNode treeNodeWithRepresentedObject:level2Data];
            [[node mutableChildNodes] addObject:level2Node];
        }
        [roots addObject:node];
    }
    return roots;
}


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    [self.sampleTreeController setContent:[self generateTree]];
    
}

- (IBAction)checkContents:(id)sender {
    for (Customer *cust in self.customersArrayController.arrangedObjects)
    {
        NSLog(@"customer %@ %@, bank balance: $%ld",
              cust.firstName, cust.lastName, cust.bankBalance);
    }
}

@end
