//
//  STYAppDelegate.m
//  Hour16Demo
//
//  Created by Kevin Hoffman on 9/10/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "STYAppDelegate.h"

@implementation STYAppDelegate
@synthesize customSheetWindow = _customSheetWindow;


@synthesize displaySheetButton = _displaySheetButton;
@synthesize window = _window;
@synthesize accessoryView = _accessoryView;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}

- (IBAction)displayAlert:(id)sender {
    NSString *alertKey = @"DisplayCustomAlert";
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    
    if ([defaults boolForKey:alertKey]) {
        NSLog(@"Alert display suppressed.");
    } else {
        NSAlert *alert = [[NSAlert alloc] init];
        alert.messageText = @"Custom Alert";
        alert.informativeText = @"This is a custom alert.";
        alert.showsSuppressionButton = YES;
        alert.accessoryView = self.accessoryView;
        [alert runModal];
        if (alert.suppressionButton.state == NSOnState) {
            [defaults setBool:YES forKey:alertKey];
        }
    }
    
}
- (IBAction)displaySheet:(id)sender {
    [NSApp beginSheet:self.customSheetWindow
       modalForWindow:self.window
        modalDelegate:self
       didEndSelector:@selector(didEndSheet:returnCode:contextInfo:)
          contextInfo:nil];
}

- (NSRect)window:(NSWindow *)window
    willPositionSheet:(NSWindow *)sheet usingRect:(NSRect)rect
{
    NSRect buttonRect = [self.displaySheetButton frame];
    buttonRect.size.height = 0;
    return buttonRect;
    
}

- (void)didEndSheet:(NSWindow *)sheet
         returnCode:(NSInteger)returnCode
        contextInfo:(void *)contextInfo
{
    [sheet orderOut:self];
    
    // handle whatever the user did to the window
    // while it was open...
}

- (IBAction)closeSheet:(id)sender {
    NSLog(@"About to close sheet...");
    [NSApp endSheet:self.customSheetWindow];
}
@end
