//
//  STYAppDelegate.m
//  CoreImageFilters
//
//  Created by Kevin Hoffman on 9/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "STYAppDelegate.h"
#import <QuartzCore/QuartzCore.h>

@implementation STYAppDelegate

@synthesize window = _window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application

    
}


- (IBAction)loadInputImage:(id)sender {
    NSOpenPanel *openPanel = [NSOpenPanel openPanel];
    openPanel.canChooseFiles = YES;
    openPanel.canChooseDirectories = NO;
    openPanel.canCreateDirectories = NO;
    openPanel.allowedFileTypes = [NSArray arrayWithObjects:@"png", @"jpg", @"gif", nil];
    
    if ([openPanel runModal] == NSOKButton) {
        NSLog(@"User selected %@", openPanel.URL);
        // Process the file..
        
        CIImage *sourceImage = [CIImage imageWithContentsOfURL:openPanel.URL];
        
        CIFilter *monoFilter;
        NSDictionary *filterAttributes;
        monoFilter = [CIFilter filterWithName:@"CIColorMonochrome"];
        [monoFilter setDefaults];
        filterAttributes = [monoFilter attributes];
        NSLog(@"mono attributes: %@", filterAttributes);
        
        [monoFilter setValue:sourceImage forKey:@"inputImage"];
        
        CIImage *resultImage = [monoFilter valueForKey:@"outputImage"];
        
        
        NSBitmapImageRep *bitmapRep = [[NSBitmapImageRep alloc] initWithCIImage:resultImage];
        NSData *pngData = [bitmapRep representationUsingType:NSPNGFileType properties:nil];
        BOOL result = [pngData writeToFile:@"/Users/runemage/Desktop/converted.png" atomically:NO];
        if (!result)
        {
            NSLog(@"Failed to write output to disk.");
        }
    }
}
@end
